Module Module1

  Sub Main()
    Dim N As Integer
    Dim X(1), B(1), A(1, 1) As Double
    Dim I, J, nChoice As Integer
    Dim sInput As String

    Do
      Console.WriteLine("       Solve a system of linear equations")
      Console.WriteLine("       ==================================")
      Console.WriteLine("0) Quit")
      Console.WriteLine("1) New system")
      Console.WriteLine("2) Edit matrix A")
      Console.WriteLine("3) Edit vector B")
      Console.WriteLine("4) View coefficients")
      Console.WriteLine("5) Solve")
      Console.Write("Select choice bu number: ")
      sInput = Console.ReadLine
      If sInput.Length > 0 Then
        nChoice = Integer.Parse(sInput)
      Else
        nChoice = -1
      End If
      Console.WriteLine()
      Select Case nChoice
        Case 0
          Console.WriteLine("Bye!")
        Case 1
          Console.Write("Enter number of equations? ")
          N = Integer.Parse(Console.ReadLine)
          ReDim X(N), B(N), A(N, N)
          For I = 0 To N - 1
            For J = 0 To N - 1
              Console.Write("Enter A({0},{1})? ", I + 1, J + 1)
              A(I, J) = Double.Parse(Console.ReadLine)
            Next
            Console.Write("Enter B({0})? ", I + 1)
            B(I) = Double.Parse(Console.ReadLine)
          Next
        Case 2
          Console.Write("Enter value of index I? ")
          I = Integer.Parse(Console.ReadLine) - 1
          Console.Write("Enter value of index J? ")
          J = Integer.Parse(Console.ReadLine) - 1
          Console.Write("Enter new value of A({0},{1})? ({2}): ", I + 1, J + 1, A(I, J))
          sInput = Console.ReadLine
          If sInput.Length > 0 Then
            A(I, J) = Double.Parse(sInput)
          End If
        Case 3
          Console.Write("Enter value of index I? ")
          I = Integer.Parse(Console.ReadLine) - 1
          Console.Write("Enter new value of B({0})? ({1}): ", I + 1, B(I))
          sInput = Console.ReadLine
          If sInput.Length > 0 Then
            A(I, J) = Double.Parse(sInput)
          End If
        Case 4
          For I = 0 To N - 1
            For J = 0 To N - 1
              Console.WriteLine("A({0},{1}) = {2} ", I + 1, J + 1, A(I, J))
            Next
            Console.WriteLine("B({0}) = {1} ", I + 1, B(I))
          Next
        Case 5
          For I = 0 To N - 1
            X(I) = B(I)
          Next
          MatrixLibVb.SolveLU(A, X, N)
          Console.WriteLine("Solution is:")
          For I = 0 To N - 1
            Console.WriteLine("X({0}) = {1}", I + 1, X(I))
          Next
      End Select

      If nChoice > 0 Then
        Console.WriteLine()
        Console.Write("Press Enter to resume")
        Console.ReadLine()
        Console.WriteLine()
      End If

    Loop Until nChoice = 0

  End Sub

End Module
